/*

Sa 26. Nov 14:35:11 CET 2022
Fr 14. Apr 08:54:24 CEST 2023	skip nullbyte lines
Di 25. Apr 21:50:25 CEST 2023	direct read from stdin

reinhard@finalmedia.de
PUBLIC DOMAIN

read every line and prepend crc32 checksum, followed by space

no performance optimization.
crc32c polynominal in reversed bit order, used by iscsi.
todo: use a lookup table, to get performance boost.

*/

#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>

uint32_t crc32(uint32_t crc, const unsigned char *buf, size_t len)
{
    int i;
    crc = ~crc;
    while (len--) {
        crc ^= *buf++;
        for (i = 0; i < 8; i++)
         crc = (crc >> 1) ^ (0x82f63b78 & (0 - (crc & 1)));
    }
    return ~crc;
}


int main()
{
    FILE *fp;
    char *line = NULL;
    size_t len = 0;
    size_t read;
    char separator=' ';
    size_t keyfield=1;

    while ((read = getline(&line, &len, stdin)) != -1) {

    if (strlen(line)>0) {
        if (getenv("prepend_decimal")) printf("%u %s", (uint32_t) crc32(0, line, len), line);
        else printf("%08x %s", crc32(0, line, len), line);
	fflush(stdout);
    }
    }

    free(line);
    return 0;
}
